A = create_testmatrix;
n = size(A,1)
%%%spy(A) 
%%-----------------------------------------
%% create artificial rhs
rhs = A * ([1:n]') ; 
%% random initial guess
sol0 = rand(n,1); 
%%-----------------------------------------
% read parameters from file 
  ARMSopt = arms_params;
%----------------------------------------- 
%
 disp(' solution with SSOR -GMRES') 
 L = tril(A); 
 D = diag(diag(A));
 U = triu(A);
 L = L * inv(D);
 PRE = struct('L',L,'U',U,'P',eye(n));
 filfact1=  ( nnz(L) + nnz(U) - n) / nnz(A) 
 disp(' Done ')
%------------------------------------------ 
% call fgmres accelerator
[sol,res1,its1]=fgmres(A,PRE,'precLU',...
   rhs, sol0,ARMSopt);
 disp(' ** done ** ') 
%-------------------------------------------
semilogy([0:its1],res1,'linestyle','--','marker','*','LineWidth',2,'color','r') 
 hold on;
% repeat with ILU(0) 
 disp(' solution with ILU(0) -GMRES') 
% call ILU  from matlab -- store result
% in struct PRE 
 [L, U, P]= luinc(A,'0');
 PRE = struct('L',L,'U',U,'P',P);
 filfact2 =  ( nnz(L) + nnz(U) - n) / nnz(A) 
%------------------------------------------ 
% call fgmres accelerator
[sol,res2,its2]=fgmres(A,PRE,'precLU',...
   rhs, sol0,ARMSopt);
 disp(' ** done ** ') 
semilogy([0:its2],res2,'r-','LineWidth',2,'color','r') 
 hold on;
%%%%%%%% ILU(1)
%% [L, U]= iluk(A,1);
%% PRE = struct('L',L,'U',U,'P',eye(n));
%------------------------------------------ 
% call fgmres accelerator
%%[sol,res3,its3]=fgmres(A,PRE,'precLU',...
%%   rhs, sol0,ARMSopt);
%% disp(' ** done ** ') 
%%semilogy([0:its3],res3,'b-','LineWidth',2)
%% hold on;
%%%%%%%% ILU(2)
 [L, U]= iluk(A,2);
 filfact3 =  ( nnz(L) + nnz(U) - n) / nnz(A) 
 PRE = struct('L',L,'U',U,'P',eye(n));
%------------------------------------------ 
% call fgmres accelerator
[sol,res4,its4]=fgmres(A,PRE,'precLU',...
   rhs, sol0,ARMSopt);
 disp(' ** done ** ') 
semilogy([0:its4],res4,'b--','LineWidth',2)
 hold on;

%%%%%%%% IC+RB ordering
 p = [1:2:n, 2:2:n];
 B = A(p,p);
 rhs1 = rhs(p); sol0 = sol0(p);
 R = cholinc(B,'0');
 PRE = struct('R',R);
 filfact5 = 1;
%------------------------------------------ 
% call PCG accelerator
 [sol,res6]=PCG(B,PRE,'precChol',rhs,sol0,...
 ARMSopt);
 its6 = length(res6) -1;
 disp(' ** done ** ') 
semilogy([0:its6],res6,'k--','LineWidth',2)
 hold on;

%%  filfact1, filfact2, filfact3, filfact4

%%%%%%%% IC+RB ordering
 p = [1:2:n, 2:2:n];
 B = A'*A;  rhs1 = A'*rhs;
 R = cholinc(B+0.0*speye(n,n),'0');
 PRE = struct('R',R);
%------------------------------------------ 
% call PCG accelerator
 [sol,res7]=PCG(B,PRE,'precChol',rhs1,sol0,...
 ARMSopt);
 its7 = length(res7) -1;
 disp(' ** done ** ') 
semilogy([0:its7],res7,'k:','LineWidth',2)
 hold on;

%%  filfact1, filfact2, filfact3, filfact4
